# problem.py

import re
from result import *

class problem:
  ''' This class represents a single regex problem to be solved by the user.'''
  EASY_LIST, FULL_LIST, FULL_TEXT = range(3)
  title = None
  problemtype = None
  goodwords = None
  badwords = None
  fulltext = None # For FULL_TEXT
  explanation = None
  regex = None
  hint = None

  def __init__(self):
    self.title = ''
    self.problemtype = problem.EASY_LIST
    self.goodwords = []
    self.badwords = []
    self.fulltext = ''
    self.explanation = ''
    self.regex = ''
    hint = ''
  
  def from_tuple(self, data):
    self.title = data[0]
    self.problemtype = data[1]
    if self.problemtype == problem.FULL_TEXT:
      self.fulltext = data[3]
    else:
      self.goodwords = data[3]
      self.badwords = data[4]
    self.explanation = data[2]
    self.regex = data[5]
    self.hint = data[6]

  def get_result(self, regex):
    res = result()
    res.prob = self
    try:
      rgx = re.compile(regex)
    except:
      self.regex_error = True
      return res
    if self.problemtype == problem.EASY_LIST:
      res.good_match = 0
      res.bad_match = 0
      for word in self.goodwords:
        mo = rgx.search(word)
        if mo is None:
          res.good_dict[word] = None
        else:
          res.good_dict[word] = (mo.span())
          res.good_match += 1
      for word in self.badwords:
        mo = rgx.search(word)
        if mo is None:
          res.bad_dict[word] = None
        else:
          res.bad_dict[word] = (mo.span())
          res.bad_match += 1
      if res.good_match == len(self.goodwords) and res.bad_match == 0:
        res.success = True
      else:
        res.success = False
    return res

