#result.py

class result:
  '''This is the result set from applying a regex to a problem.'''
  success = None
  regex_error = None
  # list mode results here:
  good_dict = None  # dictionary of highlight tuples, None means none
  bad_dict = None
  good_match = None
  bad_match = None
  # full string mode results here:
  highlights = None # list of highlight index tuples, eg. [(0,50),(6,7)]
  prob = None

  def __init__(self):
    self.success = False
    self.regex_error = False
    self.good_dict = {}
    self.bad_dict = {}
    self.good_match = 0
    self.bad_match = 0
    self.highlights = []
    self.prob = None
    
  def matched_good(self):
    li = [wd for wd in self.prob.goodwords 
      if not self.good_dict.get(wd, None) is None]
    return li

  def matched_bad(self):
    li = [wd for wd in self.prob.badwords 
      if not self.bad_dict.get(wd, None) is None]
    return li
